'***************************************  Axes Setup Program  ***************************************
' File:			AX_SETUP.PRG
' Purpose:		Axes setup example
' Version:		V1.0.0.0
' History:		11:31:56 17/10/2017 - V1.0.0.0 Created
' Author:		AUTOMATICALLY GENERATED by AX_SETUP_Gen.py
' Description:	This script configures each axis' parameters according to the user's specifications in
'				the softMC Configurator.
'
' Global Variables Used: num_Of_Motion_Drives as long  - Number of ECat Motion Drives found by EC_SETUP.PRG
'						Axes[64] - An array that holds all the axes in the system. Defined in CONFIG.PRG
'********************************************************************************************************

' module global variables
common shared AX_SETUP_PRG_error_code as long
common shared AX_SETUP_PRG_error_str as string

common shared ERR_AX_SETUP as error "ERROR SETTING UP AXES. CHECK AX_SETUP_PRG_error_code / AX_SETUP_PRG_error_STR" 20765

common shared dHomingFactorFast as double = 0.5
common shared dHomingFactorslow as double = 0.25
common shared dHomingFactorAcc as double = 0.1
common shared dSec2msec as double = 1000  '  this is used to convert from typical user time-units [msec] to typical drive time-units [sec]
common shared dHomingVelocity as double
common shared dHomingAcceleration as double
common shared dVelocityLimit as double
common shared dDrivePeMax as double
common shared mm_to_inch as double = (1/25.4)
common shared pfac_of_drive as double = 1000000
common shared ax_setup_pitch as double = 1

Program
	call Setup_Axis_1

	print "Axes Setup Finished Successfully !"

AX_SETUP_PRG_DONE:

End Program


Sub Setup_Axis_1

	dim retStr as string

	if Execute_VES("with A1", 1) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("AXISTYPE = 1", 1037) <> 0 then
		throw ERR_AX_SETUP
	end if

  pfac_of_drive = 1.0*(EC_SDO_READ(1,0x6092,1)/EC_SDO_READ(1,0x6092,2))*(EC_SDO_READ(1,0x6091,1)/EC_SDO_READ(1,0x6091,2))
	if Execute_VES("PFAC= pfac_of_drive ", 1043) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VFAC = PFAC/1000", 1043) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("AFAC = PFAC/(1000*1000)", 1043) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("JFAC = PFAC/(1000*1000*1000)", 1043) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Simulated = 0", 1050) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionErrorDelay = 4.11", 1051) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("MotionBusVelocityScale = 0", 1052) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("MotionBusVelocityBase = 1000", 1053) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("CountMin = -2147483648", 1054) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("CountMax = 2147483647", 1055) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("CountRollOver = 0", 1056) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionExternalFactor = 1", 1057) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Direction = 1", 1058) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("DirectionExternal = 1", 1059) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Displacement = 0", 1060) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityExternalFactor = 1", 1061) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueFactor = 1", 1062) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionErrorSettle = 1.79769e+308", 1063) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeSettleMax = -1", 1064) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeSettle = 0", 1065) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Absolute = 0", 1066) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityCruise = 5", 1067) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Acceleration = 1000", 1068) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Deceleration = 1000", 1069) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("DecStop = 1000", 1070) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Jerk = 15*ACC", 1071) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("Wrap = 0", 1072) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("ProfilerType = -1", 1073) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("SmoothFactor = -1", 1074) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("StartType = 3", 1075) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("StopType = 1", 1076) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("ProceedType = 3", 1077) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("DisableTimeout = 22000", 1078) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionMax = 1.79769e+308", 1079) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionMin = -1.79769e+308", 1080) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionMaxEnable = 0", 1081) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionMinEnable = 0", 1082) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionErrorMax = 0.01", 1083) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionRollOver = 360", 1084) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionRollOverEnable = 0", 1085) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionRollOverMin = -180", 1086) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionExtRollOver = 360", 1087) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionExtRollOverEnable = 0", 1088) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionExtRollOverMin = -180", 1089) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityMax = 200", 1090) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityOverSpeed = 1.2*VMAX", 1091) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocitySafetyLimit = 10*VMAX", 1092) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("AccelerationMax = 1000", 1093) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("DecelerationMax = 1000", 1094) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("JerkMax = 1.5*DecelerationMax", 1095) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueErrorMax = 100000", 1096) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueMax = 10000", 1097) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueChangeRatioMax = 1", 1098) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityOverride = 100", 1099) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityRate = 100", 1100) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("AccelerationRate = 100", 1101) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("DecelerationRate = 100", 1102) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("JerkRate = 100", 1103) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("JerkAccelerationPercentage = 100", 1104) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("JerkDecelerationPercentage = 100", 1105) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("BlendingFactor = 100", 1106) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("BlendingFactorPrevious = -1", 1107) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("BlendingMethod = 1", 1108) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("BlendingStartCondition = 0", 1109) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("CP = 0", 1110) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("CPPrev = -1", 1111) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueErrorDisableType = 0", 1112) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueErrorEnable = 0", 1113) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueErrorFilter = 1.0", 1114) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueErrorStopType = 3", 1115) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueChangeRatio = 1.0", 1116) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("HoldType = 0", 1117) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("DynamicModel = 0", 1118) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("ModelOffset = 0", 1119) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("CoulombFriction = 0", 1120) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("ViscousFriction = 0", 1121) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PayloadInertia = 0", 1122) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PayloadMass = 0", 1123) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("AbsEnable = 1", 1124) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("VelocityLimitTorqueMax = 1000", 1125) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TorqueLimitVelocityMax = 10000", 1126) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeOfShortMotions = 0", 1127) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeAcceleration = -1", 1128) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeDeceleration = -1", 1129) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeAccMin = 0", 1130) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("TimeDecMin = 0", 1131) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionBacklash = 0", 1132) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("PositionBacklashAlpha = 0.9", 1133) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("FastDataEnable = 0", 1134) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("mastersource = NONE", 1135) <> 0 then
		throw ERR_AX_SETUP
	end if

	if Execute_VES("slave = OFF", 1136) <> 0 then
		throw ERR_AX_SETUP
	end if

	attach A1
		call EC_SET_MOTION_OPMODE(A1, 0)
	detach A1

	retStr = VesExecute("end with")

	print "Done setting motion and homing parameters to axis A1"

End Sub


function Execute_VES(byval command as string, byval err_code as long) as long

	dim retStr as string

	Execute_VES = 0
	AX_SETUP_PRG_error_code = 0
	retStr = VesExecute(command)

	if INSTR(retStr, "E:Error") <> 0  then

		AX_SETUP_PRG_error_code = err_code
		AX_SETUP_PRG_error_str = retStr
		Execute_VES = -1

	end if

end function

