'***************************************  Robot Setup Program  ***************************************
' File:			ROBOT_SETUP.PRG
' Purpose:		Axes setup example
' Version:		V1.0.0.0
' History:		11:31:57 17/10/2017 - V1.0.0.0 Created
' Author:		AUTOMATICALLY GENERATED by ROBOT_SETUP_Gen.py
' Description:	This script configures each robot' parameters according to the user's specifications in
'				the softMC Configurator.
'
' Global Variables Used: num_Of_Motion_Drives as long  - Number of ECat Motion Drives found by EC_SETUP.PRG
'						Axes[64] - An array that holds all the axes in the system. Defined in CONFIG.PRG
'********************************************************************************************************

' module global variables
import_c PUMA_SET_THETA(byval as long, byval as long,byval as double) as double
import_c SCARA_SET_THETA(byval as long, byval as long,byval as double) as double

common shared ROBOT_PRG_error_code as long
common shared ROBOT_PRG_error_str as string

common shared ERR_ROBOT_SETUP as error "ERROR SETTING UP robot " 20766

common shared dHomingFactorFast as double = 0.5
common shared total_dh as double
common shared dHomingFactorslow as double = 0.25
common shared dHomingFactorAcc as double = 0.1
common shared dSec2msec as double = 1000  '  this is used to convert from typical user time-units [msec] to typical drive time-units [sec]
common shared dHomingVelocity as double
common shared dHomingAcceleration as double
common shared dVelocityLimit as double
common shared dDrivePeMax as double
common shared mm_to_inch as double = 0.0393701
common shared help as double = 1

Program

dim retStr as string

End program

function Execute_VES(byval command as string, byval err_code as long) as long

	dim retStr as string

	Execute_VES = 0
	ROBOT_PRG_error_code = 0
	retStr = VesExecute(command)

	if INSTR(retStr, "E:Error") <> 0  then

		ROBOT_PRG_error_code = err_code
		ROBOT_PRG_error_str = retStr
		Execute_VES = -1

	end if

end function

